#ifndef ABSTRACTSOFTWARE_SEEN
#define ABSTRACTSOFTWARE_SEEN

#include "globalParameters.h"
#include "particleBeam.h"

#include <iostream>
#include <string>

using namespace std;

class dataManager;

class abstractSoftware
{

 protected :

  globalParameters* globParamPtr_;
  dataManager* dataManager_;
  string inputFileName_;

  abstractSoftware();

  bool launchJob(string commandLine, string& resul);

 public :

  abstractSoftware(string inputFileName, globalParameters* globals, dataManager* dt);
  ~abstractSoftware() {;}

  virtual bool createInputFile(particleBeam* beamBefore,unsigned int numeroDeb, unsigned int numeroFin, string workingDir) = 0;


  virtual bool  execute(unsigned int numeroDeb,unsigned int numeroFin,string workingDir) = 0;

 virtual bool buildBeamAfterElements(unsigned int numeroDeb,unsigned int numeroFin, vector<particleBeam>& beams, string workingDir) = 0;

    /** Color of the background of this sofware
     Should be a valid Css name as FFEEDD
     */
    virtual string getColor() = 0;

    /** Name of this software
     */
    virtual string getName() = 0;

};
#endif
